#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <iostream>
#include <fstream>
#include <cmath>

//#define INF 10000

using namespace std;

void DTW(vector<float> query, vector<float> song, float **dtw, char *clas){	  
    for(int i = 1; i < query.size(); ++i)
		dtw[i][0] = INFINITY;
	
	for(int j = 0; j < song.size(); ++j)
		dtw[0][j] = abs(query[0] - song[j]);
	
	for(int i = 1; i < query.size(); ++i)
		for(int j = 1; j < song.size(); ++j){
			float m = INFINITY, aux;
			if(i > 1)
				m = dtw[i - 2][j - 1];
			aux = dtw[i - 1][j - 1];
			if(aux < m)
				m = aux;
			if(j > 1){
				aux = dtw[i - 1][j - 2];
				if(aux < m)
					m = aux;
			}
			dtw[i][j] = abs(query[i] - song[j]) + m;
		}
	float m = INFINITY;
	for(int i = 0; i < song.size(); ++i)
		if(dtw[query.size() - 1][i] < m)
			m = dtw[query.size() - 1][i];
			
	//printf("%s %f\n",clas,m);
			
	for(int i = 0; i < song.size(); ++i){
		/*if(dtw[query.size() - 1][i] == m)
			printf("%s %f\n",clas,dtw[query.size() - 1][i]);*/
		if(dtw[query.size() - 1][i] != INFINITY)
			printf("%s %f\n",clas,dtw[query.size() - 1][i]);
		/*else
			printf("%s %f\n",clas,1000000000.0);*/
	}
		
}

float DTW(vector<float> query, vector<float> song, float **dtw){
    /*float **dtw = new float*[query.size()];
    for(int i = 0; i < query.size(); ++i)
		dtw[i] = new float[song.size()];*/
	  
    for(int i = 1; i < query.size(); ++i)
		dtw[i][0] = INFINITY;
	
	for(int j = 0; j < song.size(); ++j)
		dtw[0][j] = abs(query[0] - song[j]);
	
	for(int i = 1; i < query.size(); ++i)
		for(int j = 1; j < song.size(); ++j){
			float m = INFINITY, aux;
			if(i > 1)
				m = dtw[i - 2][j - 1];
			aux = dtw[i - 1][j - 1];
			if(aux < m)
				m = aux;
			if(j > 1){
				aux = dtw[i - 1][j - 2];
				if(aux < m)
					m = aux;
			}
			dtw[i][j] = abs(query[i] - song[j]) + m;
			//printf("%d %d %f %f %f %f\n",i,j,m,query[i],song[j],dtw[i][j]);
		}
	int m = INFINITY;
	for(int i = 0; i < song.size(); ++i)
		if(dtw[query.size() - 1][i] < m)
			m = dtw[query.size() - 1][i];
	return m;
    //return dtw[query.size() - 1][song.size() - 1];
}

float DTW2(vector<float> query, vector<float> song, float **dtw2){
    float **dtw = new float*[query.size() + 1];
    for(int i = 0; i < query.size() + 1; ++i)
			dtw[i] = new float[song.size() + 1];

    for(int i = 1; i <= query.size(); ++i)
			dtw[i][0] = INFINITY;

        for(int j = 1; j <= song.size(); ++j)
			dtw[0][j] = abs(query[0] - song[j - 1]);

        for(int i = 1; i <= query.size(); ++i)
			for(int j = 1; j <= song.size(); ++j){
				float m = INFINITY, aux;
				if(i > 1)
						m = dtw[i - 2][j - 1];
				aux = dtw[i - 1][j - 1];
				if(aux < m)
						m = aux;
				if(j > 1){
						aux = dtw[i - 1][j - 2];
						if(aux < m)
								m = aux;
				}
				dtw[i][j] = abs(query[i - 1] - song[j - 1]) + m;
				//printf("%d %d %f %f %f %f\n",i,j,m,query[i],song[j],dtw[i][j]);                                                                                                                            
			}
	int m = INFINITY;
	for(int i = 0; i < song.size(); ++i)
		if(dtw[query.size() - 1][i] < m)
			m = dtw[query.size() - 1][i];
	return m;
    //return dtw[query.size()][song.size()];
}

int main(int argc, char **argv){
	if(argc < 3 || argc > 4){
		fprintf(stderr, "Usage: %s query song {-k}\n",argv[0]);
		exit(-1);
	}
	vector<float> query, song, nsong;
	float t;
	float n;
	ifstream f1, f2;
	f1.open(argv[1]);
	if(!f1.is_open())
		exit(-1);
	while(f1 >> t >> n){
		//printf("%f %f\n",t,n);
		query.push_back(n);
	}
	f1.close();
	f2.open(argv[2]);
	if(!f2.is_open())
		exit(-1);
	while(f2 >> t >> n){
		//printf("%f %f\n",t,n);
		song.push_back(n);
	}
	f2.close();
			
	float **dtw = new float*[query.size()];
    for(int i = 0; i < query.size(); ++i)
		dtw[i] = new float[song.size()];
		
	if(argc == 3){
		//printf("%f\n",DTW(query, song, dtw));
		DTW(query, song, dtw, argv[2]);
		//printf("%s %f\n",argv[2],DTW(query, song, dtw));
		return 0;
	}
	
	int center = 0, span = 4;
	float distance = INFINITY;
	float mq = 0, ms = 0;
	for(int i = 0; i < query.size(); ++i)
		mq += query[i];
	for(int i = 0; i < song.size(); ++i)
		ms += song[i];
	mq /= query.size();
	ms /= song.size();
	for(int i = 0; i < song.size(); ++i)
			nsong.push_back(abs(song[i] - ms));
	while(span > 1){
		vector<float> aux1, aux2, aux3;
		for(int i = 0; i< query.size(); ++i){
			/*aux1.push_back(max((float) 0, query[i] - center - span - mq));
			aux2.push_back(max((float) 0, query[i] - center - mq));
			aux3.push_back(max((float) 0, query[i] - center + span - mq));*/
			
			aux1.push_back(abs(query[i] - center - span - mq));
			aux2.push_back(abs(query[i] - center - mq));
			aux3.push_back(abs(query[i] - center + span - mq));
		}
		float a,b,c;
		a = DTW(aux1, nsong, dtw);
		//a = INFINITY;
		b = DTW(aux2, nsong, dtw);
		c = DTW(aux3, nsong, dtw);
		//c = INFINITY;
		float m = a;
		if(b < m)
			m = b;
		if(c < m)
			m = c;
		if(m == a)
			center -= span;
		if(m == c)
			center += span;
		if(m < distance)
			distance = m;
		//printf("%f %f\n",b,distance);
		span /= 2;
	}
	
	//printf("%f\n",DTW(query, song, dtw));
	//printf("%f\n",distance);
	printf("%s %f\n",argv[2],distance);
	return 0;
}
