#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

float distance3(vector<float> query, vector<float> song, int q, int s){
	float **d = new float*[q + 1];
	for(int i = 0; i < q + 1; ++i)
		d[i] = new float[s + 1];
		
	for(int i = 0; i < q + 1; ++i)
		d[i][0] = i;
	for(int j = 0; j < s + 1; ++j)
		d[0][j] = 0;
		
	for(int i = 1; i < q + 1; ++i)
		for(int j = 1; j < s + 1; ++j){
			int del = d[i][j - 1] + abs(song[j - 1]) + 1;
			int ins = d[i - 1][j] + abs(query[i - 1]) + 1;
			int subs = d[i - 1][j - 1] + abs(query[i - 1] - song[j - 1]);
			
			if(i == q)
				del = d[i][j - 1];
			
			int m = del;
			if(ins < m)
				m = ins;
			if(subs < m)
				m = subs;
			if(query[i - 1] == song[j - 1] && d[i - 1][j - 1] < m) //Matching
				m = d[i - 1][j - 1];
				
			d[i][j] = m;
		}
		
	return d[q][s];
}

int distance4(char *query, char *song, int q, int s){
	int **d = new int*[q + 1];
	for(int i = 0; i < q + 1; ++i)
		d[i] = new int[s + 1];
		
	for(int i = 0; i < q + 1; ++i)
		d[i][0] = i;
	for(int j = 0; j < s + 1; ++j)
		d[0][j] = 0;
		
	for(int i = 1; i < q + 1; ++i)
		for(int j = 1; j < s + 1; ++j){
			int del = abs(d[i][j - 1] + 2 * (query[i] - song[j]));
			int ins = abs(d[i - 1][j] + 1 * (query[i] - song[j]));
			int subs = abs(d[i - 1][j - 1] + 3 * (query[i] - song[j]));
			
			if(i == q)
				del = d[i][j - 1];
			
			int m = del;
			if(ins < m)
				m = ins;
			if(subs < m)
				m = subs;
			/*if(query[i - 1] == song[j - 1] && d[i - 1][j - 1] < m) //Matching
				m = d[i - 1][j - 1];*/
				
			d[i][j] = m;
		}
		
	return d[q][s];
}

int distance2(char *query, char *song, int q, int s){
	int **d = new int*[q + 1];
	for(int i = 0; i < q + 1; ++i)
		d[i] = new int[s + 1];
		
	for(int i = 0; i < q + 1; ++i)
		d[i][0] = i;
	for(int j = 0; j < s + 1; ++j)
		d[0][j] = 0;
		
	for(int i = 1; i < q + 1; ++i)
		for(int j = 1; j < s + 1; ++j){
			int del = d[i][j - 1] + /*2*/ 1;
			int ins = d[i - 1][j] + 1;
			int subs = d[i - 1][j - 1] + /*3*/ 1;
			
			if(i == q)
				del = d[i][j - 1];
			
			int m = del;
			if(ins < m)
				m = ins;
			if(subs < m)
				m = subs;
			if(query[i - 1] == song[j - 1] && d[i - 1][j - 1] < m) //Matching
				m = d[i - 1][j - 1];
				
			d[i][j] = m;
		}
		
	return d[q][s];
}

int distance(char *query, char *song, int q, int s){
	int **d = new int*[q + 1];
	for(int i = 0; i < q + 1; ++i)
		d[i] = new int[s + 1];
		
	d[0][0] = 0;
	for(int i = 1; i < q + 1; ++i)
		d[i][0] = d[i - 1][0] + 1;
	for(int j = 1; j < s + 1; ++j)
		d[0][j] = d[0][j - 1] + 1;
		
	for(int j = 1; j < s + 1; ++j)
		for(int i = 1; i < q + 1; ++i){
			int del = d[i - 1][j] + 1;
			int ins = d[i][j - 1] + 1;
			int subs = d[i - 1][j - 1] + 1;
			
			int m = del;
			if(ins < m)
				m = ins;
			if(subs < m)
				m = subs;
			if(query[i - 1] == song[j - 1] && d[i - 1][j - 1] < m) //Matching
				m = d[i - 1][j - 1];
				
			d[i][j] = m;
		}
		
	/*int m = INFINITY;
	for(int i = 0; i < s + 1; ++i)
		if(d[q][i] < m)
			m = d[q][i];
	return m;*/
		
	return d[q][s];
}

int main(int argc, char **argv){
	if(argc < 3 || argc > 4){
		fprintf(stderr, "Usage: %s query song {-k}\n",argv[0]);
		exit(-1);
	}
	vector<float> query, song;
	float t, n;
	ifstream f1, f2;
	
	f1.open(argv[1]);
	while(f1 >> t >> n){
		query.push_back(n);
	}
	f1.close();
	
	f2.open(argv[2]);
	while(f2 >> t >> n){
		song.push_back(n);
	}
	f2.close();
	
	char *nquery, *nsong;
	nquery = new char[query.size() - 1];
	nsong = new char[song.size() - 1];
	
	int *nQuery, *nSong;
	nQuery = new int[query.size() - 1];
	nSong = new int[song.size() - 1];
	
	for(int i = 1; i < query.size(); ++i){
		if(query[i] > query[i - 1]){
			nquery[i - 1] = 'U';
			nQuery[i - 1] = 1;
		}
		else if(query[i] == query[i - 1]){
			nquery[i - 1] = 'S';
			nQuery[i - 1] = 0;
		}
		else{
			nquery[i - 1] = 'D';
			nQuery[i - 1] = -1;
		}
	}
	
	for(int i = 1; i < song.size(); ++i){
		if(song[i] > song[i - 1]){
			nsong[i - 1] = 'U';
			nSong[i - 1] = 1;
		}
		else if(song[i] == song[i - 1]){
			nsong[i - 1] = 'S';
			nSong[i - 1] = 0;
		}
		else{
			nsong[i - 1] = 'D';
			nSong[i - 1] = -1;
		}
	}
	printf("%d\n",distance2(nquery, nsong, query.size() - 1, song.size() - 1));
	//printf("%d\n",distance4(nquery, nsong, query.size() - 1, song.size() - 1));
	//printf("%f\n",distance3(query, song, query.size(), song.size()));
	return 0;
}

