#!/bin/bash

# Copyright (C) 1997 by Alfons Juan, Pattern Recognition and Artificial
# Intelligence Group, Technological Institute of Computer Science,
# Valencia University of Technology, Valencia (Spain).
#
# Permission to use, copy, modify, and distribute this software and its
# documentation for any purpose and without fee is hereby granted, provided
# that the above copyright notice appear in all copies and that both that
# copyright notice and this permission notice appear in supporting
# documentation.  This software is provided "as is" without express or
# implied warranty.

function usage 
{
cat <<-EOF >&2

usage: ${0##*/} [-h] [-s seed] [file]

Shuffles the lines of file.

EOF
}

SEED=0
while getopts :hs: OPT; do
    case $OPT in
	h)  usage; exit 0;;
	s)  SEED="$OPTARG";;
	*)  usage; exit 1
    esac
done
shift $[ OPTIND - 1 ]

if [ $# -eq 0 ] ; then
    zcat -f -
else
    zcat -f $1
fi | awk -v s=$SEED 'BEGIN{if (s) srand(s)}
{
    l[n++]=$0
}
END{
    for (i=0; i<n; i++){
	j=int(rand()*(n-i));
	print l[j];
	l[j]=l[n-i-1]
    }
}'




